#include "w25qxx.h"
uint16_t W25QXX_TYPE = 0XFFFF;	//ĬW25Q128

//4KbytesΪһSector
//16Ϊ1Block
//W25Q128
//Ϊ16Mֽ,256Block,4096Sector
static void delayus(uint32_t nus){
    volatile uint32_t i;
    while (nus-- > 0){
      i = 26;
      while (i-- > 0);
    }
}
/**
 * @brief ʼSPI,ESP32һ4SPIõ.hļѡesp32esp32s3
 * 
 */
void SPI1S_Init(void){
        // gpio init
    // pinMode(NORFLASH_HOLD_PIN, OUTPUT); 
    // pinMode(NORFLASH_WP_PIN, OUTPUT);
    // digitalWrite(NORFLASH_HOLD_PIN, HIGH);  //
    // digitalWrite(NORFLASH_WP_PIN, HIGH);   //д
#ifdef HARDWARE_SPI
    //ʹӲSPI
    SPI.begin(NORFLASH_CLK_PIN, NORFLASH_MISO_PIN, NORFLASH_MOSI_PIN, NORFLASH_CS_PIN);
    SPI.setDataMode(SPI_MODE0);
    SPI.setBitOrder(MSBFIRST);
    SPI.setFrequency(SPI_FREQUENCY);
    // SPI.setFrequency(1000000*20);
    pinMode(NORFLASH_CS_PIN, OUTPUT);
#endif
#ifdef SOFTWARE_SPI
    //ʹģSPI
    pinMode(NORFLASH_CLK_PIN, OUTPUT);
    pinMode(NORFLASH_MOSI_PIN, OUTPUT);
    pinMode(NORFLASH_MISO_PIN, INPUT);
    pinMode(NORFLASH_CS_PIN, OUTPUT);

    digitalWrite(NORFLASH_CS_PIN,HIGH);
    digitalWrite(NORFLASH_CLK_PIN,LOW);
    delay(1);
#endif
#ifdef FLASH_TEST_ENABLE
    /* readwrite test */
    int g = 0;
    uint8_t str[512];
    memset(str, 0, sizeof(str));
    unsigned int  j = 0;       
    for(int k=0; k < 2; k++)
    {
      for(int i = 0; i < 256; i++)
      {
        str[j] = i;
        j++;
      }
    }
    Serial.println("");
    Serial.println("-----write data-------");
    W25QXX_CS0;
    W25QXX_Erase_Sector(0x00);
    for (uint8_t i = 0; i < 2; i++)
    {
        W25QXX_Write(&str[256*i],256*i,256);
    }
    memset(str, 0, sizeof(str));
    W25QXX_Read(str,0x00,512);
    W25QXX_CS1;
    Serial.println("str:");
    for(int k = 0; k < 512; k++) {
      if(g == 16){
            Serial.println("|");
            if(k % 256 == 0) Serial.println("---------------");
            g = 1;
        }
        else  g++;
        Serial.printf("%02X ", str[k]);
    }
#endif
}
/**
 * @brief дһֽ
 * 
 * @param TxData Ҫдֽ
 * @return uint8_t ȡֽ
 */
uint8_t SPI1_ReadWriteByte(uint8_t TxData)
{
    uint8_t Rxdata;
#ifdef HARDWARE_SPI
    Rxdata = SPI.transfer(TxData);
    return Rxdata;
#endif
#ifdef SOFTWARE_SPI
    for(uint8_t i = 0; i < 8; i++) {
      uint8_t status;
      status = TxData & (0x80 >> i);
      digitalWrite(NORFLASH_MOSI_PIN, status);
      digitalWrite(NORFLASH_CLK_PIN, LOW);
      digitalWrite(NORFLASH_CLK_PIN, HIGH);

    if(digitalRead(NORFLASH_MISO_PIN)) {
        Rxdata |= 0x80 >> i;
    }
    }
    return Rxdata;
#endif
    return Rxdata;          		    //յ
}

/**
 * @brief ʼSPI FLASHIO
 * 
 */
void W25QXX_Init(void)
{
	SPI1S_Init();		   			        //ʼSPI
  W25QXX_TYPE = W25QXX_ReadID();	        //ȡFLASH ID.
}

//ȡW25QXX״̬ĴW25QXXһ3״̬Ĵ
//״̬Ĵ1
//BIT7  6   5   4   3   2   1   0
//SPR   RV  TB BP2 BP1 BP0 WEL BUSY
//SPR:Ĭ0,״̬Ĵλ,WPʹ
//TB,BP2,BP1,BP0:FLASHд
//WEL:дʹ
//BUSY:æλ(1,æ;0,)
//Ĭ:0x00
//״̬Ĵ2
//BIT7  6   5   4   3   2   1   0
//SUS   CMP LB3 LB2 LB1 (R) QE  SRP1
//״̬Ĵ3
//BIT7      6    5    4   3   2   1   0
//HOLD/RST  DRV1 DRV0 (R) (R) WPS ADP ADS
//regno:״̬Ĵţ:1~3
//ֵ:״̬Ĵֵ
/**
 * @brief ȡW25QXX״̬Ĵ
 * 
 * @param regno ״̬Ĵţ:1~3
 * @return uint8_t ״̬Ĵֵ
 */
uint8_t W25QXX_ReadSR(uint8_t regno)
{
    uint8_t byte=0,command=0;
    switch(regno)
    {
        case 1:
            command = W25X_ReadStatusReg1;    //״̬Ĵ1ָ
            break;
        case 2:
            command = W25X_ReadStatusReg2;    //״̬Ĵ2ָ
            break;
        case 3:
            command = W25X_ReadStatusReg3;    //״̬Ĵ3ָ
            break;
        default:
            command = W25X_ReadStatusReg1;
            break;
    }
    W25QXX_CS0;                            //ʹ
    SPI1_ReadWriteByte(command);            //Ͷȡ״̬Ĵ
    byte=SPI1_ReadWriteByte(0Xff);          //ȡһֽ
    W25QXX_CS1;                            //ȡƬѡ
    return byte;
}
//дW25QXX״̬Ĵ
void W25QXX_Write_SR(uint8_t regno,uint8_t sr)
{
    uint8_t command=0;
    switch(regno)
    {
        case 1:
            command=W25X_WriteStatusReg1;    //д״̬Ĵ1ָ
            break;
        case 2:
            command=W25X_WriteStatusReg2;    //д״̬Ĵ2ָ
            break;
        case 3:
            command=W25X_WriteStatusReg3;    //д״̬Ĵ3ָ
            break;
        default:
            command=W25X_WriteStatusReg1;
            break;
    }
    W25QXX_CS0;                            //ʹ
    SPI1_ReadWriteByte(command);            //дȡ״̬Ĵ
    SPI1_ReadWriteByte(sr);                 //дһֽ
    W25QXX_CS1;                            //ȡƬѡ
}
//W25QXXдʹ
//WELλ
void W25QXX_Write_Enable(void)
{
    W25QXX_CS0;                            //ʹ
    SPI1_ReadWriteByte(W25X_WriteEnable);   //дʹ
    W25QXX_CS1;                            //ȡƬѡ
}
//W25QXXдֹ
//WEL
void W25QXX_Write_Disable(void)
{
  W25QXX_CS0;                            //ʹ
  SPI1_ReadWriteByte(W25X_WriteDisable);  //дָֹ
  W25QXX_CS1;                            //ȡƬѡ
}

//ȡоƬID
//ֵ:
//0XEF13,ʾоƬͺΪW25Q80
//0XEF14,ʾоƬͺΪW25Q16
//0XEF15,ʾоƬͺΪW25Q32
//0XEF16,ʾоƬͺΪW25Q64
//0XEF17,ʾоƬͺΪW25Q128
//0XEF18,ʾоƬͺΪW25Q256
uint16_t W25QXX_ReadID(void)
{
    uint16_t Temp = 0;
    W25QXX_CS0;
    SPI1_ReadWriteByte(0x90);//ͶȡID
    SPI1_ReadWriteByte(0x00);
    SPI1_ReadWriteByte(0x00);
    SPI1_ReadWriteByte(0x00);
    Temp|=SPI1_ReadWriteByte(0xFF)<<8;
    Temp|=SPI1_ReadWriteByte(0xFF);
    W25QXX_CS1;
    return Temp;
}
/**
 * @brief ȡSPI FLASHַָʼȡָȵ
 * 
 * @param pBuffer ݴ洢
 * @param ReadAddr ʼȡĵַ(24bit)
 * @param NumByteToRead Ҫȡֽ(65535)
 */
void W25QXX_Read(uint8_t* pBuffer,uint32_t ReadAddr,uint16_t NumByteToRead)
{
    uint16_t i;
    W25QXX_CS0;                            //ʹ
    SPI1_ReadWriteByte(W25X_ReadData);      //Ͷȡ
    if(W25QXX_TYPE==W25Q256)                //W25Q256ĻַΪ4ֽڵģҪ8λ
    {
        SPI1_ReadWriteByte((uint8_t)((ReadAddr)>>24));
    }
    SPI1_ReadWriteByte((uint8_t)((ReadAddr)>>16));   //24bitַ
    SPI1_ReadWriteByte((uint8_t)((ReadAddr)>>8));
    SPI1_ReadWriteByte((uint8_t)ReadAddr);
    for(i=0; i<NumByteToRead; i++)
    {
        pBuffer[i]=SPI1_ReadWriteByte(0XFF);    //ѭ
    }
    W25QXX_CS1;
}
/**
 * @brief һҳ(w25q12865536ҳ,ÿһҳ256ֽڣһ16Mֽ)д256ֽڵݣַָʼд256ֽڵ
 * 
 * @param pBuffer ݴ洢
 * @param WriteAddr ʼдĵַ(24bit)
 * @param NumByteToWrite Ҫдֽ(256),Ӧóҳʣֽ!!!
 */
void W25QXX_Write_Page(uint8_t* pBuffer,uint32_t WriteAddr,uint16_t NumByteToWrite)
{
    uint16_t i;
    W25QXX_Write_Enable();                  //SET WEL
    W25QXX_CS0;                            //ʹ
    SPI1_ReadWriteByte(W25X_PageProgram);   //дҳ
    if(W25QXX_TYPE==W25Q256)                //W25Q256ĻַΪ4ֽڵģҪ8λ
    {
        SPI1_ReadWriteByte((uint8_t)((WriteAddr)>>24));
    }
    SPI1_ReadWriteByte((uint8_t)((WriteAddr)>>16)); //24bitַ
    SPI1_ReadWriteByte((uint8_t)((WriteAddr)>>8));
    SPI1_ReadWriteByte((uint8_t)WriteAddr);
    for(i=0;i<NumByteToWrite;i++)SPI1_ReadWriteByte(pBuffer[i]); //ѭд
    W25QXX_CS1;                            //ȡƬѡ
    W25QXX_Wait_Busy();					   //ȴд
}
/**
 * @brief ֻдһҳݣպ256ֽ.
 * 
 * @param pBuffer д256ֽ
 * @param WriteAddr flashĵַȷҳĿͷַ256
 * @return uint8_t 󷵻1ɷ0
 */
uint8_t W25QXX_Write_Page_Only(uint8_t* pBuffer,uint16_t WriteAddr){
    uint16_t i;
    if ((WriteAddr%256)!=0){
        return 1;    //Ҫдĵַҳ׵ֱַӷ
    }
    W25QXX_Write_Enable();                  //SET WEL
    W25QXX_CS0;                            //ʹ
    SPI1_ReadWriteByte(W25X_PageProgram);   //дҳ
    if(W25QXX_TYPE==W25Q256){                //W25Q256ĻַΪ4ֽڵģҪ8λ
        SPI1_ReadWriteByte((uint8_t)((WriteAddr)>>24));
    }
    SPI1_ReadWriteByte((uint8_t)((WriteAddr)>>16)); //24bitַ
    SPI1_ReadWriteByte((uint8_t)((WriteAddr)>>8));
    SPI1_ReadWriteByte((uint8_t)WriteAddr);
    SPI.writeBytes(pBuffer,256);   //д256
    W25QXX_CS1;                            //ȡƬѡ
    W25QXX_Wait_Busy();					   //ȴд
    return 0;
}
/**
 * @brief ޼дSPI FLASHȷдĵַΧڵȫΪ0XFF,ڷ0XFFдݽʧ!Զҳ
 * ַָʼдָȵ,ҪȷַԽ!
 * 
 * @param pBuffer ݴ洢
 * @param WriteAddr ʼдĵַ(24bit)
 * @param NumByteToWrite Ҫдֽ(65535)
 */
void W25QXX_Write_NoCheck(uint8_t* pBuffer,uint32_t WriteAddr,uint16_t NumByteToWrite)
{
    uint16_t pageremain;
    pageremain=256-WriteAddr%256; //ҳʣֽ
    if(NumByteToWrite<=pageremain)pageremain=NumByteToWrite;//256ֽ
    while(1)
    {
        W25QXX_Write_Page(pBuffer,WriteAddr,pageremain);
        if(NumByteToWrite==pageremain)break;//д
        else //NumByteToWrite>pageremain
        {
            pBuffer+=pageremain;
            WriteAddr+=pageremain;

            NumByteToWrite-=pageremain;			  //ȥѾд˵ֽ
            if(NumByteToWrite>256)pageremain=256; //һοд256ֽ
            else pageremain=NumByteToWrite; 	  //256ֽ
        }
    };
}
uint8_t W25QXX_BUFFER[4096];
/**
 * @brief дSPI FLASHַָʼдָȵ.ú!˺ȫֶһuint8_t W25QXX_BUFFER[4096];
 * 
 * @param pBuffer 洢
 * @param WriteAddr ݿʼдĵַ(24bit)
 * @param NumByteToWrite Ҫдֽ(65535)
 */
void W25QXX_Write(uint8_t* pBuffer,uint32_t WriteAddr,uint32_t NumByteToWrite)
{
    uint32_t secpos;
    uint16_t secoff;
    uint16_t secremain;
    uint16_t i;
    uint8_t * W25QXX_BUF;
    W25QXX_BUF=W25QXX_BUFFER;
    secpos=WriteAddr/4096;//ַ
    secoff=WriteAddr%4096;//ڵƫ
    secremain=4096-secoff;//ʣռС
// 	printf("ad:%X,nb:%X\r\n",WriteAddr,NumByteToWrite);//
    if(NumByteToWrite <= secremain) secremain = NumByteToWrite;    //ʣռС
    while(1)
    {
        W25QXX_Read(W25QXX_BUF,secpos*4096,4096);//
        for(i=0; i<secremain; i++) //У
        {
            if(W25QXX_BUF[secoff+i]!=0XFF) break;//Ҫ
        }
        if(i<secremain)//Ҫ
        {
            W25QXX_Erase_Sector(secpos);//
            for(i=0; i<secremain; i++)	 //
            {
                W25QXX_BUF[i+secoff]=pBuffer[i];
            }
            W25QXX_Write_NoCheck(W25QXX_BUF,secpos*4096,4096);//д

        }
        else W25QXX_Write_NoCheck(pBuffer,WriteAddr,secremain); //дѾ˵,ֱдʣ.
        if(NumByteToWrite==secremain) break;//д
        else//дδ
        {
            secpos++;//ַ1
            secoff=0;//ƫλΪ0

            pBuffer+=secremain;  //ָƫ
            WriteAddr+=secremain;//дַƫ
            NumByteToWrite-=secremain;				//ֽݼ
            if(NumByteToWrite>4096)secremain=4096;	//һд
            else secremain=NumByteToWrite;			//һд
        }
    };
}
//оƬ
//ȴʱ䳬...
void W25QXX_Erase_Chip(void)
{
    W25QXX_Write_Enable();                  //SET WEL
    W25QXX_Wait_Busy();
    W25QXX_CS0;                            //ʹ
    SPI1_ReadWriteByte(W25X_ChipErase);        //Ƭ
    W25QXX_CS1;                            //ȡƬѡ
    W25QXX_Wait_Busy();   				   //ȴоƬ
}
/**
 * @brief һ,һʱ:150ms
 * 
 * @param Dst_Addr ַ ʵ
 */
void W25QXX_Erase_Sector(uint32_t Dst_Addr)
{
    //falsh,
    //printf("fe:%x\r\n",Dst_Addr);
    Dst_Addr*=4096;
    W25QXX_Write_Enable();                  //SET WEL
    W25QXX_Wait_Busy();
    W25QXX_CS0;                            //ʹ
    SPI1_ReadWriteByte(W25X_SectorErase);   //ָ
    if(W25QXX_TYPE==W25Q256)                //W25Q256ĻַΪ4ֽڵģҪ8λ
    {
        SPI1_ReadWriteByte((uint8_t)((Dst_Addr)>>24));
    }
    SPI1_ReadWriteByte((uint8_t)((Dst_Addr)>>16));  //24bitַ
    SPI1_ReadWriteByte((uint8_t)((Dst_Addr)>>8));
    SPI1_ReadWriteByte((uint8_t)Dst_Addr);
    W25QXX_CS1;                            //ȡƬѡ
    W25QXX_Wait_Busy();   				    //ȴ
}
//ȴ
void W25QXX_Wait_Busy(void)
{
    while((W25QXX_ReadSR(1)&0x01)==0x01);   // ȴBUSYλ
}
//ģʽ
void W25QXX_PowerDown(void)
{
    W25QXX_CS0;                            //ʹ
    SPI1_ReadWriteByte(W25X_PowerDown);     //͵
    W25QXX_CS1;                            //ȡƬѡ
    delayus(3);                            //ȴTPD
}
//
void W25QXX_WAKEUP(void)
{
    W25QXX_CS0;                                //ʹ
    SPI1_ReadWriteByte(W25X_ReleasePowerDown);  //  send W25X_PowerDown command 0xAB
    W25QXX_CS1;                                //ȡƬѡ
    delayus(3);                                //ȴTRES1
}
